<?php
/**------------------------------------------------------------------------
 * mod_vikspeakers - VikSpeakers
 * ------------------------------------------------------------------------
 * author    Alessio Gaggii - e4j - Extensionsforjoomla.com
 * copyright Copyright (C) 2021 e4j - Extensionsforjoomla.com. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: https://e4j.com
 * Technical Support:  tech@e4j.com
 * ------------------------------------------------------------------------
*/

defined('_JEXEC') or die ('Restricted access');

jimport('joomla.form.formfield');

class JFormFieldVikSpeakersmanager extends JFormField {
	protected $type = 'VikSpeakersmanager';

	protected function getInput() {
		$top_form = '<div id="vikspeakers-slides-container">'.
					'	<div id="vikspeakers-slides-add-wrapper">'.
					'		<a href="#add"><span class="icon-plus-circle"></span>'.JText::_('VIKSPADDSLIDE').'</a>'.
					'	</div>'.
					'	<div id="vikspeakers-slides-add-form">'.$this->loadFormData('add').'</div>'.
					'</div>';
		
		$edit_form = $this->loadFormData('edit');
		
		$data_form = '<div id="invisible" style="display: none;">'.
					'	<div class="vikspeakers-slider-entry">'.
					'		<div class="vikspeakers-slider-entry-inner">'.
					'			<div class="vikspeakers-slider-divtitle"><span class="vikspeakers-slider-title" title="'.JText::_('VIKTITLEDESC').'"></span></div>'.
					'			<div class="vikspeakers-slider-edit">'.
					//'			<span class="vikspeakers-slider-img"></span>'.
					'			<div class="vikspeakers-slider-remove"><a href="#remove" class="vikspeakers-slider-removebtn" title="'.JText::_('VIKSPREMOVESLIDE').'"><span class="icon-unpublish"></span>'.JText::_('VIKSPREMOVESLIDE').'</a></div>'.
					'			<div class="vikspeakers-slider-editbtn"><a href="#edit" class="vikspeakers-slider-editbtn" title="'.JText::_('VIKSPEDITSLIDE').'"><span class="icon-pencil-2"></span><span>'.JText::_('VIKSPEDITSLIDE').'</span></a></div>'.
					'			<div class="vikspeakers-slider-preview"><a rel="{handler:\'image\'}" class="vik-modal modal-img" title="'.JText::_('VIKSPPREVIEWSLIDE').'"><span class="icon-out-2"></span>'.JText::_('VIKSPPREVIEWSLIDE').'</a></div>'.				
					'			<div class="vikspeakers-slider-status"><div class="vikspeakers_publishediv"><span class="icon-radio-checked"></span><span class="vikspeakers_published">'.JText::_('VIKSPPUBLISHEDSLIDE').'</span></div><div class="vikspeakers_unpublisheddiv"><span class="icon-radio-unchecked"></span><span class="vikspeakers_unpublished">'.JText::_('VIKSPUNPUBLISHEDSLIDE').'</span></div></div>'.
					'		</div></div>'.
					'		<div class="vikspeakers-slider-editcontainer">'.
					'			<div class="vikspeakers-slider-editor">'.$edit_form.'</div>'.
					'		</div>'.
					'	</div>'.
					'</div>';
		
		$slides_list = '<div id="vikspeakers-allslides"></div>';

		$val_container = '<textarea name="'.$this->name.'" id="'.$this->id.'" style="display: none;">'.$this->value.'</textarea>';
		
		return $data_form . $top_form . $slides_list . $val_container;
	}
	
	private function loadFormData($type = 'add') {

		$is_j4 = false;
		$version = new JVersion();
		if (version_compare($version->getShortVersion(), '4.0') >= 0) {
			$is_j4 = true;
		}
		
		$form_data = '';

		$media_mng_link_add  = 'index.php?option=com_media&view=images&tmpl=component&asset=com_modules&author=&fieldid=jform_params_img&folder=';
		$media_mng_link_edit = 'index.php?option=com_media&view=images&tmpl=component&asset=&author=&fieldid=jform_params_edit_img&folder=';

		if ($type == 'add') {
			// Joomla JS function for Media Manager
			$jscript = '	function jInsertFieldValue(value,id) {'."\n";
			$jscript .= '		var old_id = document.getElementById(id).value;'."\n";
			$jscript .= '		if (old_id != id) {'."\n";
			$jscript .= '			document.getElementById(id).value = value;'."\n";
			$jscript .= '		}'."\n";
			$jscript .= '	}'."\n";
			JFactory::getDocument()->addScriptDeclaration($jscript);
			//

			// Slide IMG
			$form_data .= '<div class="vikspeakers-slideparam-block">';
			$form_data .= '	<div class="control-label"><label>'.JText::_('VIKSPIMGBGSLIDE').'</label></div>';
			if ($is_j4) {
				$form_data .= $this->getMediaField('jform[params][img]', null, ['id' => 'jform_params_img', 'class'=> 'vikspeakersparam_'.$type.'_image']);
			} else {
				$form_data .= '<div class="input-group">';
					$form_data .= '	<input type="text" name="jform[params][img]" id="jform_params_img" value="" class="form-control vikspeakersparam_'.$type.'_image" />';
					$form_data .= '	<a class="btn modal modal-media" title="'.JText::_('JSELECT').'" href="' . $media_mng_link_add . '" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('JSELECT').'</a>';
				$form_data .= '	<a title="'.JText::_('JCLEAR').'" class="btn btn-outline-secondary" href="#" onclick="javascript:document.getElementById(\'jform_params_img\').value=\'\';return false;">'.JText::_('JCLEAR').'</a></p>';
				$form_data .= '</div>';
			}
			$form_data .= '</div>';
		} else {
			if ($is_j4) {
				$form_data .= '<div class="vikspeakers-slideparam-block" style="display: block !important;">';
					$form_data .= '	<div class="control-label"><label>'.JText::_('VIKSPIMGBGSLIDE').'</label></div>';
					$form_data .= $this->getMediaField('jform_params_edit_img', null, ['id' => 'jform_params_edit_img', 'class'=> 'vikspeakersparam_'.$type.'_image']);
				$form_data .= '</div>';
			} else {
				$form_data .= '<div class="vikspeakers-slideparam-block">';
					$form_data .= '	<div class="control-label"><label>'.JText::_('VIKSPIMGBGSLIDE').'</label></div>';
					$form_data .= '	<input type="text" name="jform_params_edit_img" id="jform_params_edit_img" value="" class="form-control vikspeakersparam_'.$type.'_image" />';
					$form_data .= '	<a class="btn modal modal-media" title="'.JText::_('JSELECT').'" href="' . $media_mng_link_edit . '" target="_blank" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('JSELECT').'</a>';
					$form_data .= '	<a title="'.JText::_('JCLEAR').'" href="#" onclick="javascript:document.getElementById(\'jform_params_edit_img\').value=\'\';return false;" class="btn btn-outline-secondary modal-media-clear">'.JText::_('JCLEAR').'</a>';
				$form_data .= '</div>';
			}

		}
		// -start- Box left
			$form_data .='<div class="vikspeakers-slideparam-left">';
		//Speaker Details header 
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="vikspeakers-slideparam-header"><span class="icon-user"></span><h3>'.JText::_('VIKSPSLIDEDETAILS').'</h3></div></div>';
		//Speaker Title
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKTITLEDESC').'">'.JText::_('VIKTITLE').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_title" /></div>';
		//Speaker Position
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKPOSITIONDESC').'">'.JText::_('VIKPOSITION').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_job" /></div>';
		//Speaker Description
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKSPSLIDECAPTIONESC').'">'.JText::_('VIKSPSLIDECAPTION').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_caption" /></div>';
		//Speaker Readmore Link
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('READMOREDESC').'">'.JText::_('READMORE').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_readmore" /></div>';
		// -end- Box left
		$form_data .='</div>';
		// -start- Box right
		$form_data .='<div class="vikspeakers-slideparam-right">';
		//Speaker Social header 
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="vikspeakers-slideparam-header"><span class="icon-heart"></span><h3>'.JText::_('VIKSPSLIDESOCIAL').'</h3></div></div>';
		//Speaker Facebook Link
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKSPSLIDEFACEBOOK').'">'.JText::_('VIKSPSLIDEFACEBOOK').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_facebook" /></div>';
		//Speaker Twitter Link
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKSPSLIDETWITTER').'">'.JText::_('VIKSPSLIDETWITTER').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_twitter" /></div>';
		//Speaker Google+ Link
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKSPSLIDEGOOGLE').'">'.JText::_('VIKSPSLIDEGOOGLE').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_google" /></div>';
		//Speaker LinkedIn Link
		$form_data .= '<div class="vikspeakers-slideparam-block"><div class="control-label"><label title="'.JText::_('VIKSPSLIDELINKEDIN').'">'.JText::_('VIKSPSLIDELINKEDIN').'</label></div><input type="text" class="form-control vikspeakersparam_'.$type.'_linkedin" /></div>';
		// -end- Box right
		$form_data .='</div>';
		//Speaker Published
		$form_data .= '<div class="vikspeakers-slideparam-block vikspeakers-slideparam-status"><label>'.JText::_('VIKSPSLIDESTATUS').'</label><select class="custom-select vikspeakersparam_'.$type.'_published"><option value="1">'.JText::_('VIKSPPUBLISHEDSLIDE').'</option><option value="0">'.JText::_('VIKSPUNPUBLISHEDSLIDE').'</option></select></div>';
		//Add/Cancel buttons
		$form_data .= '<div class="vikspeakers-slideparam-block vikspeakers-slideparam-block-'.$type.'"><a href="#save" class="btn btn-success">'.JText::_('VIKSPBTNADDSLIDE').'</a><a href="#cancel" class="btn btn-outline-danger">'.JText::_('VIKSPBTNCANCSLIDE').'</a></div>';
				
		return '<div class="vikspeakers-newslide-cont"><div class="vikspeakers-newslide-cont-'.$type.'">'.$form_data.'</div></div>';
	}
	/**
	 * Method used to obtain a Joomla media form field.
	 * Compatible with J4.
	 *
	 * @return 	string 	The media in HTML.
	 *
	 * @since 	September 2021
	 */
	private function getMediaField($name, $value = null, array $data = array())
	{
		// init media field
		$field = new JFormFieldMedia(null, $value);
		// setup an empty form as placeholder
		$field->setForm(new JForm('vikspeakers.media'));

		// force field attributes
		$data['name']  = $name;
		$data['value'] = $value;

		/**
		 * J4.x requires us to use the magic method to set the properties id and types
		 * or the media manager won't work in case of multiple instances on the same page,
		 * nor would it display any image unless the proper types is passed.
		 */

		static $index = 1;
		// use an incremental value for the id
		$field->id = preg_replace("/[^A-Za-z0-9\-_]+/", '', $name) . $index++;
		// accept all images
		$field->types = 'images';

		if (empty($data['previewWidth']))
		{
			// there is no preview width, set a defualt value
			// to make the image visible within the popover
			$data['previewWidth'] = 480;
		}

		// render the field	
		return $field->render('joomla.form.field.media', $data);
	}
}
